package util

import "sync"

// LockingBool is a lockable bool
type LockingBool struct {
	sync.RWMutex
	data bool
}

// NewLockingBool creates a new LockingBool
func NewLockingBool() LockingBool {
	return LockingBool{}
}

// Set will lock and set a lockingBool
func (i *LockingBool) Set(val bool) {
	i.Lock()
	defer i.Unlock()
	i.data = val
}

// Get will Rlock and get a lockingBool
func (i *LockingBool) Get() bool {
	i.RLock()
	defer i.RUnlock()
	return i.data
}
